import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.Test;

import tempo.Tempo;

class SubtrairTempo_test {

	@Test
	void test() {
		Tempo tempo, entrada, saida;
		
		entrada = new Tempo();
		tempo = null;
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);	
		
		entrada = new Tempo();
		tempo = new Tempo();
		saida = new Tempo(0, 0, 0);
		assertEquals(entrada.subtrairTempo(tempo), saida);	
		
		entrada = new Tempo(0, 0, -1);
		tempo = new Tempo();
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(0, -3, 0);
		tempo = new Tempo();
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(0, -3, -1);
		tempo = new Tempo();
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(-7, 0, 0);
		tempo = new Tempo();
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(-5, -3, 0);
		tempo = new Tempo();
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(-3, -2, -1);
		tempo = new Tempo();
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(1, 2, 3);
		tempo = new Tempo(0, 0, -3);
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(2, 2, 2);
		tempo = new Tempo(0, -2, 0);
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(0, 0, 0);
		tempo = new Tempo(0, -5, -4);
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(5, 6, 7);
		tempo = new Tempo(-9, 0, 0);
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(9, 9, 9);
		tempo = new Tempo(-3, -2, 0);
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(3, 2, 1);
		tempo = new Tempo(-3, -2, -1);
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(0, 0, 60);
		tempo = new Tempo();
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(0, 60, 0);
		tempo = new Tempo();
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(0, 60, 70);
		tempo = new Tempo();
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(24, 0, 0);
		tempo = new Tempo();
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(25, 60, 0);
		tempo = new Tempo();
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(26, 65, 75);
		tempo = new Tempo();
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);		
		
		entrada = new Tempo(1, 2, 3);
		tempo = new Tempo(0, 0, 60);
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(2, 2, 2);
		tempo = new Tempo(0, 60, 0);
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(0, 0, 0);
		tempo = new Tempo(0, 65, 70);
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(5, 6, 7);
		tempo = new Tempo(25, 0, 0);
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(9, 9, 9);
		tempo = new Tempo(24, 60, 0);
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(3, 2, 1);
		tempo = new Tempo(25, 65, 75);
		saida = null;
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(2, 2, 2);
		tempo = new Tempo(1, 1, 1);
		saida = new Tempo(22, 58, 59);
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(0, 0, 0);
		tempo = new Tempo(12, 30, 30);
		saida = new Tempo(12, 30, 30);
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(12, 00, 00);
		tempo = new Tempo(10, 58, 59);
		saida = new Tempo(22, 58, 59);
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(12, 30, 00);
		tempo = new Tempo(12, 29, 59);
		saida = new Tempo(23, 59, 59);
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(14, 15, 15);
		tempo = new Tempo(14, 15, 15);
		saida = new Tempo(0, 0, 0);
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(16, 25, 10);
		tempo = new Tempo(22, 45, 50);
		saida = new Tempo(6, 20, 40);
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(22, 45, 50);
		tempo = new Tempo(16, 25, 10);
		saida = new Tempo(17, 39, 20);
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(10, 58, 59);
		tempo = new Tempo(12, 00, 00);
		saida = new Tempo(1, 1, 1);
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(1, 30, 0);
		tempo = new Tempo(0, 0, 0);
		saida = new Tempo(22, 30, 0);
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
		entrada = new Tempo(3, 30, 0);
		tempo = new Tempo(12, 30, 0);
		saida = new Tempo(9, 0, 0);
		assertEquals(entrada.subtrairTempo(tempo), saida);
		
	}

}
